//
// THIS FILE IS COPYRIGHT 1994, 1995 BY TELENOR RESEARCH, NORWAY
//
//                        ALL RIGHTS RESERVED.
//
// For rights granted to the public see the COPYRIGHT file
//
//
// main.cc	The main routine for the FFW date index program.
//		ffwdateindex generates the date index for a ffw index.
//		Date indices are normally generated by index and merge,
//		this program can be used to add date index to old indices
//		or repair broken/lost date indices.
//
// Author:  March 1995 Brd Hfjeld
//
#include <stream.h>
#include <stdlib.h>
#include <Disk.h>
#include <lang.h>

int main(int argc, char **argv)
{
    FILE *dix;
    char filename[200];
    unsigned char fakeurl[25];
    URLPTRSplaySet dateindex;
    unsigned char urlname[MAX_URLLENGTH];
    unsigned char title[MAX_TITLELENGTH];
    long date;
    unsigned long offset = 0;
    int recsize;
    
    if (argc != 2) {
	cout.form("Usage: %s indexname\n", argv[0]);
	exit(1);
    }

    Disk disk((unsigned char *) argv[1], DREAD);
    switch ((disk.error())) {
    case 0:
	break;
    case DOPEN:
	cout.form(OpenFile, argv[1]);
	exit(1);
    default:
	cout.form(UnknownError, disk.error(), "Disk::Disk()");
	exit(1);
    }

    // Open dix file for write
    strcpy(filename, argv[1]);
    strncat(filename, ".dix", 4);

    if ((dix = fopen((char *) filename, "w")) == NULL) {
	cout << OpenFile << filename << endl;
	exit(1);
    }

    offset = 0;

    // Scan URL file and build tree
    while ( disk.error() == DOK ) {
	if ((recsize=disk.GetNextURLRecord(&date, urlname, title)) >= 0) { 
	    sprintf((char *)fakeurl, "%012d%012d", date, offset);
	    
	    Url *url = new Url(fakeurl, (unsigned char *)"", date);
	    url->setOffset(offset);
            dateindex.add(url);
	    offset += recsize;
    	}
    }
    
    // Dump the index tree to file
    for (Pix i = dateindex.first(); i != 0 ; dateindex.next(i)) {
        date = dateindex(i)->date();
	offset = dateindex(i)->offset();
	fwrite(&date, sizeof(long), 1, dix);
	fwrite(&offset, sizeof(unsigned long), 1, dix);
    }

    fclose(dix);

    exit(0);
}



